<script setup lang="ts">
// import { GO_ASPECTS } from "~/utils/types/goannotation";
import type { GOAnnotation } from "~/utils/types/goannotation";

type Term = GOAnnotation["term"];

const props = defineProps<{ modelValue: Term }>();
const emit = defineEmits<{
  (e: "update:modelValue", v: Term): void;
}>();

const term = computed(() => props.modelValue);
const updateTerm = (updatedTerm: Partial<Term>) => {
  emit("update:modelValue", { ...term.value, ...updatedTerm });
};

const { fetchById, shortenGOAspect } = useOntologyService("GO");

const loading = ref(0);
const updateTermById = async (id: Term["id"]) => {
  try {
    if (!/^GO:[0-9]{7}$/.test(id)) {
      updateTerm({ id, name: "", aspect: "" });
      return;
    }

    loading.value += 1;
    const result = await fetchById(id);
    if (!result) {
      updateTerm({ id, name: "", aspect: "" });
    } else {
      updateTerm({
        id: result.id,
        name: result.name,
        aspect: shortenGOAspect(result.aspect),
      });
    }
  } catch (e) {
    updateTerm({ id, name: "", aspect: "" });
  } finally {
    loading.value -= 1;
  }
};

const updateTermByIdDebounced = useDebounceFn(updateTermById, 500);
const termDisplay = computed(() => {
  if (term.value.name) {
    return `${term.value.name} (${term.value.aspect})`;
  }
  return "";
});

const hints = {
  id: "The ID of the GO term you assign to the gene product",
};

const rules = computed(() => [
  (v: any) => !!v || "GO ID is required",
  () => (!!term.value.name && !!term.value.aspect) || "GO ID is invalid",
]);
</script>

<template>
  <InputLabel text="*GO ID:" :help="hints.id" />
  <v-text-field
    :model-value="term.id.replace(/^GO:/, '')"
    prefix="GO:"
    :counter="7"
    :hint="termDisplay"
    placeholder="0000000"
    :rules="rules"
    loading
    persistent-hint
    @update:modelValue="(id: Term['id']) => updateTermByIdDebounced(`GO:${id}`)"
  >
    <template #loader>
      <InputLoadingBar :loading="loading !== 0" />
    </template>
  </v-text-field>
</template>
